﻿/*
 * Konstruktory zmiennej
 */
// przestrzeń nazw "własny typ Variant"
namespace CustomVariant
{
  // klasa Variant
  public partial class Variant
  {
    // konstruktor bezparametrowy
    public Variant()
    {
      if (r == null) // jednorazowe tworzenie rekordu z daną Variant
      {
        r = new VariantRecord();
      }
      // dana nie była jeszcze podstawiana wartością
      isAssigned = false;
    }

    // konstruktor dla danych całkowitych
    public Variant(int x)
    {
      if (r == null) // jednorazowe tworzenie rekordu z daną Variant
      {
        r = new VariantRecord();
      }
      r.t = VariantType.isInt; // ustawienie typu isInt
      r.i = x;                 // podstawienie wartości do pola i 
      isAssigned = true;       // dana została podstawiona wartością
    }

    // konstruktor dla danych logicznych
    public Variant(bool x)
    {
      if (r == null) // jednorazowe tworzenie rekordu z daną Variant
      {
        r = new VariantRecord();
      }
      r.t = VariantType.isBool; // ustawienie typu isBool
      r.b = x;                  // podstawienie wartości do pola b
      isAssigned = true;        // dana została podstawiona wartością   
    }

    // konstruktor dla danych tekstowych
    public Variant(string x)
    {
      if (r == null) // jednorazowe tworzenie rekordu z daną Variant
      {
        r = new VariantRecord();
      }
      r.t = VariantType.isStr;  // ustawienie typu isStr
      r.s = x;                  // podstawienie wartości do pola s
      isAssigned = true;        // dana została podstawiona wartością  
    }
  }
}