﻿/*
 * Operatory podstawienia
 */
// przestrzeń nazw "własny typ Variant"
namespace CustomVariant
{
  // klasa Variant
  public partial class Variant
  {
    // operator podstawienia liczby całkowitej
    // pod zmienną typu Variant
    public static implicit operator Variant(int x)
    {
      return new Variant(x);
    }

    // operator podstawienia wartości logicznej
    // pod zmienną typu Variant
    public static implicit operator Variant(bool x)
    {
      return new Variant(x);
    }

    // operator podstawienia tekstu
    // pod zmienną typu Variant
    public static implicit operator Variant(string x)
    {
      return new Variant(x);
    }

    // operator podstawienia zmiennej typu Variant
    // pod zmienną typu int
    public static implicit operator int(Variant x)
    {
      if (x == null)       // jeżeli zmienna x jest null
      {                    // zainicjuj ją konstruktorem
        x = new Variant(); // bezparametrowym
      }
      return x.AsInt;
    }

    // operator podstawienia zmiennej typu Variant
    // pod zmienną typu bool
    public static implicit operator bool(Variant x)
    {
      if (x == null)       // jeżeli zmienna x jest null
      {                    // zainicjuj ją konstruktorem  
        x = new Variant(); // bezparametrowym
      }
      return x.AsBool;
    }

    // operator podstawienia zmiennej typu Variant
    // pod zmienną typu string
    public static implicit operator string(Variant x)
    {
      if (x == null)       // jeżeli zmienna x jest null
      {                    // zainicjuj ją konstruktorem
        x = new Variant(); // bezparametrowym
      }
      return x.AsStr;
    }
  }
}