﻿/*
 * Przykłady użycia utworzonego typu Variant
 */
using System;
using CustomVariant; // włączenie przestrzeni nazw "własny typ Variant"

// przestrzeń nazw aplikacji
namespace CustomVariantApp
{
  class Program
  {
    static void Main()
    {
      // przykłady użycia zmiennych typu Variant
      // w komentarzach podano wyświetlane na konsoli teksty

      Variant v1 = "Ala i ";
      Variant v2 = "kot";
      string s = v1 + v2;
      Console.WriteLine(s);  // Ala i kot

      v2 = 13;
      Variant v3 = true;
      int i = v2 + v3;
      Console.WriteLine(i);  // 14

      s = v1 + v2;
      Console.WriteLine(s);  // Ala i 13

      v1 = 1;
      v2 = "7";
      i = v1 + v2;
      Console.WriteLine(i);  // 8

      v2 = "pies As";
      try
      {
        s = v1 + v2;
      }
      catch (Exception e)    // Błąd rzutowania typu string na int
      {
        Console.WriteLine(e.Message);
      }

      Variant v4 = false;
      Variant v5 = 1;
      bool b = v4 + v5 + "False";
      Console.WriteLine(b);  // True;

      Variant x2 = 1;
      i = 1 + x2;
      Console.WriteLine(i);  // 2

      x2 = " i pies";
      s = "kot" + x2;
      Console.WriteLine(s);  // kot i pies

      x2 = true;
      b = false + x2;
      Console.WriteLine(b);  // True

      Console.WriteLine("\nNaciśnij dowolny klawisz.");
      Console.ReadKey();
    }
  }
}